/*
 * 机具退货申请订单
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class MachineReturnController : BaseController
    {
        public MachineReturnController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 机具退货申请订单列表

        /// <summary>
        /// 根据条件查询机具退货申请订单列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(MachineReturn data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;

            return View();
        }

        #endregion

        #region 根据条件查询机具退货申请订单列表

        /// <summary>
        /// 机具退货申请订单列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(MachineReturn data, string MakerCode, string RealName, string ToStoreNo, string ToStoreName, string AuditStatusSelect, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();

            Fields.Add("ApplyNo", "1"); //申请单号
            Fields.Add("CreateDate", "3"); //申请时间
            Fields.Add("DeviceSnNos", "2"); //SN
            Fields.Add("BrandId", "0"); //产品类型

            string condition = " and Status>-1";
            //创客编号
            if (!string.IsNullOrEmpty(MakerCode))
            {
                condition += " and UserId in (select UserId from UserForMakerCode where MakerCode='" + MakerCode + "')";
            }
            //创客名称
            if (!string.IsNullOrEmpty(RealName))
            {
                condition += " and UserId in (select UserId from UserForRealName where RealName='" + RealName + "')";
            }
            //仓库编号
            if (!string.IsNullOrEmpty(ToStoreNo))
            {
                condition += " and StoreId in (select StoreId from StoreForCode where Code='" + ToStoreNo + "')";
            }
            //仓库名称
            if (!string.IsNullOrEmpty(ToStoreName))
            {
                condition += " and StoreId in (select StoreId from StoreForName where Name='" + ToStoreName + "')";
            }
            //订单状态
            if(!string.IsNullOrEmpty(AuditStatusSelect))
            {
                condition += " and AuditStatus=" + AuditStatusSelect;
            }

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("MachineReturn", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["BrandId"] = RelationClass.GetKqProductBrandInfo(int.Parse(dic["BrandId"].ToString()));

                //发货仓库
                int ToStoreId = int.Parse(dic["ToStoreId"].ToString());
                StoreHouse store = db.StoreHouse.FirstOrDefault(m => m.Id == ToStoreId) ?? new StoreHouse();
                dic["ToStoreNo"] = store.StoreNo;
                dic["ToStoreName"] = store.StoreName;

                //创客信息
                int UserId = int.Parse(dic["UserId"].ToString());
                Users puser = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
                dic["MakerCode"] = puser.MakerCode;
                dic["MakerName"] = puser.RealName;

                //审核状态
                int AuditStatus = int.Parse(dic["AuditStatus"].ToString());
                if(AuditStatus == 0) dic["AuditStatus"] = "未审核";
                if(AuditStatus == 1) dic["AuditStatus"] = "审核通过，退货成功";
                if(AuditStatus == 2) dic["AuditStatus"] = "审核失败，退货失败";
            }
            return Json(obj);
        }

        #endregion

        #region 增加机具退货申请订单

        /// <summary>
        /// 增加或修改机具退货申请订单信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 增加机具退货申请订单

        /// <summary>
        /// 增加或修改机具退货申请订单信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(MachineReturn data, string MakerCode)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            UserForMakerCode user = db.UserForMakerCode.FirstOrDefault(m => m.MakerCode == MakerCode);
            if (user == null)
            {
                return "创客编号不存在";
            }
            Fields.Add("UserId", user.UserId);
            Fields.Add("BrandId", data.BrandId);
            Fields.Add("ToStoreId", data.ToStoreId);
            Fields.Add("DeviceNum", data.DeviceNum);
            Fields.Add("DeviceSnNos", data.DeviceSnNos);
            Fields.Add("Remark", data.Remark);

            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("MachineReturn", Fields, 0, false);
            AddSysLog(data.Id.ToString(), "MachineReturn", "add");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 修改机具退货申请订单

        /// <summary>
        /// 增加或修改机具退货申请订单信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;

            MachineReturn editData = db.MachineReturn.FirstOrDefault(m => m.Id == Id) ?? new MachineReturn();
            ViewBag.data = editData;

            Users user = db.Users.FirstOrDefault(m => m.Id == editData.UserId) ?? new Users();
            ViewBag.MakerCode = user.MakerCode;
            ViewBag.RealName = user.RealName;

            StoreHouse store = db.StoreHouse.FirstOrDefault(m => m.Id == editData.ToStoreId) ?? new StoreHouse();
            ViewBag.StoreNo = store.StoreNo;
            ViewBag.StoreName = store.StoreName;

            ViewBag.BrandName = RelationClass.GetKqProductBrandInfo(editData.BrandId);
            return View();
        }

        #endregion

        #region 修改机具退货申请订单

        /// <summary>
        /// 增加或修改机具退货申请订单信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(MachineReturn data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();


            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("MachineReturn", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "MachineReturn", "update");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 删除机具退货申请订单信息

        /// <summary>
        /// 删除机具退货申请订单信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "MachineReturn", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("MachineReturn", Fields, id);
            }
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "MachineReturn", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("MachineReturn", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "MachineReturn", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("MachineReturn", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("MachineReturn", Sort, Id);

            AddSysLog(Id.ToString(), "MachineReturn", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                db.MachineReturn.Add(new MachineReturn()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                db.SaveChanges();
            }
            AddSysLog("0", "MachineReturn", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(MachineReturn data, string MakerCode, string RealName, string ToStoreNo, string ToStoreName, string AuditStatusSelect)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("ApplyNo", "1"); //申请单号
            Fields.Add("CreateDate", "3"); //申请时间
            Fields.Add("DeviceSnNos", "2"); //SN
            Fields.Add("BrandId", "0"); //产品类型

            string condition = " and Status>-1";
            //创客编号
            if (!string.IsNullOrEmpty(MakerCode))
            {
                condition += " and UserId in (select UserId from UserForMakerCode where MakerCode='" + MakerCode + "')";
            }
            //创客名称
            if (!string.IsNullOrEmpty(RealName))
            {
                condition += " and UserId in (select UserId from UserForRealName where RealName='" + RealName + "')";
            }
            //仓库编号
            if (!string.IsNullOrEmpty(ToStoreNo))
            {
                condition += " and StoreId in (select StoreId from StoreForCode where Code='" + ToStoreNo + "')";
            }
            //仓库名称
            if (!string.IsNullOrEmpty(ToStoreName))
            {
                condition += " and StoreId in (select StoreId from StoreForName where Name='" + ToStoreName + "')";
            }
            //订单状态
            if(!string.IsNullOrEmpty(AuditStatusSelect))
            {
                condition += " and AuditStatus=" + AuditStatusSelect;
            }

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("MachineReturn", Fields, "Id desc", "0", 1, 20000, condition, "ApplyNo,UserId,BrandId,DeviceNum,ToStoreId,DeviceDesc,AuditStatus,Operator,Remark", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["BrandId"] = RelationClass.GetKqProductBrandInfo(int.Parse(dic["BrandId"].ToString()));

                //发货仓库
                int ToStoreId = int.Parse(dic["ToStoreId"].ToString());
                StoreHouse store = db.StoreHouse.FirstOrDefault(m => m.Id == ToStoreId) ?? new StoreHouse();
                dic["ToStoreNo"] = store.StoreNo;
                dic["ToStoreName"] = store.StoreName;

                //创客信息
                int UserId = int.Parse(dic["UserId"].ToString());
                Users puser = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
                dic["MakerCode"] = puser.MakerCode;
                dic["MakerName"] = puser.RealName;

                //审核状态
                int AuditStatus = int.Parse(dic["AuditStatus"].ToString());
                if(AuditStatus == 0) dic["AuditStatus"] = "未审核";
                if(AuditStatus == 1) dic["AuditStatus"] = "审核通过，退货成功";
                if(AuditStatus == 2) dic["AuditStatus"] = "审核失败，退货失败";

                dic.Remove("UserId");
                dic.Remove("ToStoreId");
            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            ReturnFields.Add("ApplyNo", "退货申请订单号");
            ReturnFields.Add("MakerCode", "创客编号");
            ReturnFields.Add("RealName", "创客名称");
            ReturnFields.Add("BrandId", "产品类型");
            ReturnFields.Add("DeviceNum", "创客申请退货数量");
            ReturnFields.Add("ToStoreNo", "退回仓库编号");
            ReturnFields.Add("ToStoreName", "退回仓库名称");
            ReturnFields.Add("DeviceDesc", "设备描述");
            ReturnFields.Add("AuditStatus", "订单状态");
            ReturnFields.Add("Remark", "创客退货备注");
            ReturnFields.Add("Operator", "操作人员");
            ReturnFields.Add("CreateDate", "退货申请时间");
            ReturnFields.Add("UpdateDate", "退货审核时间");
            result.Add("Fields", ReturnFields);
            AddSysLog("0", "MachineReturn", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
